%define kver 2.6.9
%define krelmaj 42
%define krelmin 20
#define krelmin %(rpm -q kernel-devel|sed 's/^.*\\.\\([0-9]\\+\\)AX$/\\1/'|sort -rug|head -n 1)
%define krpmver %{krelmaj}.%{krelmin}AX

Summary:       Aarich (Adaptec close source driver)
Name:          kernel-driver-aarich
Version:       6.00.086.I308
Release:       %{kver}_%{krpmver}_8
License:       proprietary
Group:         System Environment/Kernel
URL:           http://www.adaptec.com/
Source:        aarich-pelican_hill_phase2-ich-build86.tgz
Source1:       configs-%{kver}-11.19AX.tar.bz2
Source2:       filter-requires-kernel.sh
Patch0:        aarich-6.00.084.I308-aarich2.patch
Patch1:        aarich-rhlikekernel.patch
Patch2:        aarich-6.00.084.I308-writebuffer.patch
NoSource:      0

BuildPreReq:   kernel-devel = %{kver}-%{krpmver}
BuildPreReq:   kernel-source = %{kver}-%{krpmver}
Prereq:        kernel-%{_target_cpu} = %{kver}-%{krpmver}

BuildRoot:     %{_tmppath}/%{name}-%{version}-root
#ExclusiveArch: i686 x86_64 ppc ppc64

%define __perl_requires %{SOURCE2}

%description
This package contains the Aarich kernel module.
Note that this driver does not licensed by the 
OpenSource(TM) term.

%package -n kernel-driver-aarich2
Summary: Aarich (Adaptec close source driver) for up kernel
Group: System Environment/Kernel
Prereq: kernel-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-driver-aarich2
This package contains the Aarich kernel module.
Note that this driver does not licensed by the
OpenSource(TM) term.

%package -n kernel-smp-driver-aarich
Summary: Aarich (Adaptec close source driver) for smp kernel
Group: System Environment/Kernel
Prereq: kernel-smp-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-smp-driver-aarich
This package contains the Aarich kernel module for smp kernel

%package -n kernel-smp-driver-aarich2
Summary: Aarich (Adaptec close source driver) for smp kernel
Group: System Environment/Kernel
Prereq: kernel-smp-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-smp-driver-aarich2
This package contains the Aarich kernel module for smp kernel

%package -n kernel-hugemem-driver-aarich
Summary: Aarich (Adaptec close source driver) for hugemem kernel
Group: System Environment/Kernel
Prereq: kernel-hugemem-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-hugemem-driver-aarich
This package contains the Aarich kernel module for hugemem kernel

%package -n kernel-hugemem-driver-aarich2
Summary: Aarich (Adaptec close source driver) for hugemem kernel
Group: System Environment/Kernel
Prereq: kernel-hugemem-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-hugemem-driver-aarich2
This package contains the Aarich kernel module for hugemem kernel

%package -n kernel-largesmp-driver-aarich
Summary: Aarich (Adaptec close source driver) for largesmp kernel
Group: System Environment/Kernel
Prereq: kernel-largesmp-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-largesmp-driver-aarich
This package contains the Aarich kernel module for largesmp kernel

%package -n kernel-largesmp-driver-aarich2
Summary: Aarich (Adaptec close source driver) for largesmp kernel
Group: System Environment/Kernel
Prereq: kernel-largesmp-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-largesmp-driver-aarich2
This package contains the Aarich kernel module for largesmp kernel


%prep
%setup -q -c aarich
pushd aarich/linux/makefiles
%patch0 -p1
popd
%patch1 -p0
%patch2 -p0

## copy kernel tree for build
/bin/cp -a /usr/src/linux-%{kver}-%{krpmver} .
cd linux-%{kver}-%{krpmver}
%if "%{krpmver}" == "11.19AX"
tar jxf %{SOURCE1} -C configs
%endif
## for safe
make clean
ln -s ../../../aarich drivers/scsi/aarich
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -prep/" Makefile
#perl -p -i -e "s/^NAME.*/NAME = Asianux/" Makefile
cd ..

%build
rm -rf $RPM_BUILD_ROOT
cd linux-%{kver}-%{krpmver}

BuildDriver() {
  make -s mrproper
  KernelVer=%{kver}-%{krpmver}$1
  ModuleDir=$RPM_BUILD_ROOT/lib/modules/$KernelVer/kernel/drivers/scsi
  mkdir -p $ModuleDir
  perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krpmver}$1/" Makefile
  if [ -n "$1" ]; then
    cp -a configs/kernel-%{kver}-%{_target_cpu}-$1.config .config
  else
    cp -a configs/kernel-%{kver}-%{_target_cpu}.config .config
  fi
  if [ ! -L include/asm ]; then
    ln -sf asm-%{_arch} include/asm
  fi
  make -s nonint_oldconfig >/dev/null
  make -s include/linux/version.h
  make scripts
  ## normal module
  ln -sf linux/makefiles/Makefile.k26.aarich drivers/scsi/aarich/Makefile
  make -s SUBDIRS=drivers/scsi/aarich CONFIG_SCSI_AARICH=m modules
  strip -g drivers/scsi/aarich/aarich.ko
  cp -a drivers/scsi/aarich/aarich.ko $ModuleDir
  rm -f drivers/scsi/aarich/*o
  ## ph module
  ln -sf linux/makefiles/Makefile.k26.aarich.ph drivers/scsi/aarich/Makefile
  make -s SUBDIRS=drivers/scsi/aarich CONFIG_SCSI_AARICH=m modules
  strip -g drivers/scsi/aarich/aarich2.ko
  cp -a drivers/scsi/aarich/aarich2.ko $ModuleDir
  rm -f drivers/scsi/aarich/*o
  make clean
}

# Build driver for each kernels
BuildDriver
BuildDriver smp
%ifarch i686
BuildDriver hugemem
%endif
%ifarch ia64 x86_64
BuildDriver largesmp
%endif

cd ..

%install

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}
exit 0

%post -n kernel-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}
exit 0

%post -n kernel-smp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}smp
exit 0

%post -n kernel-smp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}smp
exit 0

%ifarch i686
%post -n kernel-hugemem-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}hugemem
exit 0

%post -n kernel-hugemem-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}hugemem
exit 0

%endif

%ifarch ia64 x86_64
%post -n kernel-largesmp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}largesmp
exit 0

%post -n kernel-largesmp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}largesmp
exit 0
%endif

%postun
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver} %{kver}-%{krpmver}
exit 0

%postun -n kernel-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver} %{kver}-%{krpmver}
exit 0

%postun -n kernel-smp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}smp %{kver}-%{krpmver}smp
exit 0

%postun -n kernel-smp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}smp %{kver}-%{krpmver}smp
exit 0

%ifarch i686
%postun -n kernel-hugemem-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}hugemem %{kver}-%{krpmver}hugemem
exit 0

%postun -n kernel-hugemem-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}hugemem %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch ia64 x86_64
%postun -n kernel-largesmp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}largesmp %{kver}-%{krpmver}largesmp
exit 0

%postun -n kernel-largesmp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}largesmp %{kver}-%{krpmver}largesmp
exit 0

%endif

%files
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}/kernel/drivers/scsi/aarich.ko

%files -n kernel-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}/kernel/drivers/scsi/aarich2.ko

%files -n kernel-smp-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}smp/kernel/drivers/scsi/aarich.ko

%files -n kernel-smp-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}smp/kernel/drivers/scsi/aarich2.ko

%ifarch i686
%files -n kernel-hugemem-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}hugemem/kernel/drivers/scsi/aarich.ko

%files -n kernel-hugemem-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}hugemem/kernel/drivers/scsi/aarich2.ko
%endif

%ifarch ia64 x86_64
%files -n kernel-largesmp-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}largesmp/kernel/drivers/scsi/aarich.ko

%files -n kernel-largesmp-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}largesmp/kernel/drivers/scsi/aarich2.ko
%endif

%changelog
* Mon Mar 10 2008 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.20AX

* Wed Dec  5 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.18AX

* Wed Oct 31 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.17AX

* Wed Sep 26 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.16AX

* Wed Jul 18 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.15AX

* Mon Jun 11 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.14AX

* Thu May 29 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.13AX

* Thu May  1 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.11AX

* Wed Mar 15 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- fixed requirement of aarich2 for up kernel
- rebuild for kernel-2.6.9-42.10AX

* Thu Feb 22 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.8AX

* Wed Jan 10 2007 Hiroshi Hara <hhara@miraclelinux.com>
- divide pkg to aarich and aarich2
- rebuild for kernel-2.6.9-42.7AX

* Fri Nov 17 2006 Hiroshi Hara <hhara@miraclelinux.com>
- rebuild for kernel-2.6.9-42.1AX

* Tue Oct 10 2006 Hiroshi Hara <hhara@miraclelinux.com>
- rebuild for kernel-2.6.9-34.28AX

* Wed May 17 2006 Shiro Yamada <shiro@miraclelinux.com> - 2.6.9_34.18AX_6
- rebuild for kernel-2.6.9-34.20AX

* Thu Apr 27 2006 Shiro Yamada <shiro@miraclelinux.com> - 2.6.9_34.17AX_5
- rebuild for kernel-2.6.9-34.17AX

* Thu Apr 13 2006 Shiro Yamada <shiro@miraclelinux.com>
- rebuild for 2.6.9-34.14AX
- deal with PreReq properly

* Tue Mar 28 2006 Shiro Yamada <shiro@miraclelinux.com>
- rebuild for Asianux 2.0 SP1
- add module for kernel-largesmp
- automatically identifies kernel release from kernel-devel package installed

* Mon Nov 28 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Strip -g

* Thu Nov 24 2005 Ryoji Kamei <kamei@miraclelinux.com>
- 6.00.086

* Tue Nov 22 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Diskdump support

* Mon Nov 14 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Fix %post fail

* Tue Nov  1 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change default write buffer flag

* Thu Oct 27 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change package name scheme to kernel-<tag>-driver-<driver_name>

* Tue Oct 25 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Initial packaging

